diff --git a/src/main/java/net/minecraft/core/block/BlockFenceGate.java b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
index 2617bb3f7..d66cf1349 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceGate.java
+++ b/src/main/java/net/minecraft/core/block/BlockFenceGate.java
@@ -3,6 +3,8 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
@@ -89,7 +91,7 @@ public class BlockFenceGate extends Block
     
     @Override
 	public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
-    	if(!player.isSneaking()) {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		blockActivated(world, x, y, z, player);
     	}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockFlower.java b/src/main/java/net/minecraft/core/block/BlockFlower.java
index 4852eefa9..13735f24d 100644
--- a/src/main/java/net/minecraft/core/block/BlockFlower.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlower.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
@@ -42,6 +43,12 @@ public class BlockFlower extends Block implements IBonemealable
         return this;
     }
 
+    @Override
+    public void onBlockPlaced(World world, int x, int y, int z, Side placeSide, EntityLiving entity, double sideHeight) {
+        if (entity instanceof EntityPlayer){
+            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b1000_0000); // Set persistent flag
+        }
+    }
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
@@ -66,7 +73,7 @@ public class BlockFlower extends Block implements IBonemealable
     {
         func_268_h(world, x, y, z);
         
-        if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().killFlowers && killedByWeather && rand.nextInt(256) == 0)
+        if (world.getSeasonManager().getCurrentSeason() != null && ((world.getBlockMetadata(x, y, z) & 0b1000_000) == 0) && world.getSeasonManager().getCurrentSeason().killFlowers && killedByWeather && rand.nextInt(256) == 0)
         {
         	world.setBlockWithNotify(x, y, z, 0);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockFluid.java b/src/main/java/net/minecraft/core/block/BlockFluid.java
index 7e695b939..45cf867fc 100644
--- a/src/main/java/net/minecraft/core/block/BlockFluid.java
+++ b/src/main/java/net/minecraft/core/block/BlockFluid.java
@@ -34,7 +34,7 @@ public abstract class BlockFluid extends Block
         return (float)(data + 1) / 8F;
     }
 
-    protected int getDepth(World world, int x, int y, int z)
+    protected int getDepth(WorldSource world, int x, int y, int z)
     {
         if(world.getBlockMaterial(x, y, z) != blockMaterial)
         {
@@ -315,4 +315,48 @@ public abstract class BlockFluid extends Block
             world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + 1.2D, (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    {
+        float f7 = BlockFluid.getFluidHeight(world, x, y, z, blockMaterial);
+        float f8 = BlockFluid.getFluidHeight(world, x, y, z + 1, blockMaterial);
+        float f9 = BlockFluid.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
+        float f10 = BlockFluid.getFluidHeight(world, x + 1, y, z, blockMaterial);
+        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
+    }
+
+    public static float getFluidHeight(WorldSource worldSource, int x, int y, int z, Material material)
+    {
+        int l = 0;
+        float f = 0.0F;
+        for(int i1 = 0; i1 < 4; i1++)
+        {
+            int j1 = x - (i1 & 1);
+            int l1 = z - (i1 >> 1 & 1);
+            if(worldSource.getBlockMaterial(j1, y + 1, l1) == material)
+            {
+                return 1.0F;
+            }
+            Material material1 = worldSource.getBlockMaterial(j1, y, l1);
+            if(material1 == material)
+            {
+                int i2 = worldSource.getBlockMetadata(j1, y, l1);
+                if(i2 >= 8 || i2 == 0)
+                {
+                    f += BlockFluid.getWaterVolume(i2) * 10F;
+                    l += 10;
+                }
+                f += BlockFluid.getWaterVolume(i2);
+                l++;
+                continue;
+            }
+            if(!material1.isSolid())
+            {
+                f++;
+                l++;
+            }
+        }
+
+        return Math.max(1.0F - f / (float)l, 0.015F);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockLever.java b/src/main/java/net/minecraft/core/block/BlockLever.java
index c0dc45b1f..ab833806a 100644
--- a/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -4,6 +4,8 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
@@ -189,7 +191,7 @@ public class BlockLever extends Block
     @Override
     public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
     {
-    	if(!player.isSneaking()) {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		blockActivated(world, x, y, z, player);
     	}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
index 632843ee6..7f88d6f2c 100644
--- a/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
+++ b/src/main/java/net/minecraft/core/block/BlockMotionSensor.java
@@ -58,7 +58,8 @@ public class BlockMotionSensor extends BlockTileEntityRotatable
 	private void spawnParticles(World world, int x, int y, int z) {
 		Random random = world.rand;
 
-		Color color = Colors.allRedstoneColors[10];
+        final int redstoneBrightness = 10;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -80,7 +81,7 @@ public class BlockMotionSensor extends BlockTileEntityRotatable
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
index fe4305123..2c3bf3034 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
@@ -99,7 +99,8 @@ public class BlockOreRedstone extends Block
     private void spawnParticles(World world, int x, int y, int z) {
 		Random random = world.rand;
 
-		Color color = Colors.allRedstoneColors[10];
+        final int redstoneBrightness = 10;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -123,7 +124,7 @@ public class BlockOreRedstone extends Block
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 			}
 		}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstone.java b/src/main/java/net/minecraft/core/block/BlockRedstone.java
index 400adb7f8..ee1add575 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstone.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstone.java
@@ -65,7 +65,8 @@ public class BlockRedstone extends Block
 	private void spawnParticles(World world, int x, int y, int z) {
 		Random random = world.rand;
 
-		Color color = Colors.allRedstoneColors[10];
+        final int redstoneBrightness = 10;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -87,7 +88,7 @@ public class BlockRedstone extends Block
 			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
+				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
index 402f83cff..7722ed4f6 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneRepeater.java
@@ -213,7 +213,8 @@ public class BlockRedstoneRepeater extends Block
 		double xOffset = 0.0;
 		double zOffset = 0.0;
 
-		Color color = Colors.allRedstoneColors[10];
+        final int redstoneBrightness = 15;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -253,7 +254,7 @@ public class BlockRedstoneRepeater extends Block
 				break;
 			}
 		}
-		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue, 0);
+		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue, redstoneBrightness);
 	}
 
     public static final double field_22024_a[] = {
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java b/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
index eb26cb3a2..08eeceed7 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneTorch.java
@@ -210,7 +210,8 @@ public class BlockRedstoneTorch extends BlockTorch
 		double verticalOffset = 0.22D;
 		double horizontalOffset = 0.27D;
 
-		Color color = Colors.allRedstoneColors[10];
+        final int redstoneBrightness = 10;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -219,15 +220,15 @@ public class BlockRedstoneTorch extends BlockTorch
 		float blue = color.getBlue() / 255.0f;
 		
 		if (meta == 1) {
-			world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, 0);
+			world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
 		} else if (meta == 2) {
-			world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, 0);
+			world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
 		} else if (meta == 3) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, 0);
+			world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, redstoneBrightness);
 		} else if (meta == 4) {
-			world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, 0);
+			world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, redstoneBrightness);
 		} else {
-			world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
+			world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 		}
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
index 67ece3c5a..7ed042869 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
@@ -427,7 +427,8 @@ public class BlockRedstoneWire extends Block
 		double py = (double) y + 0.0625D;
 		double pz = (double) z + 0.5D + (rand.nextFloat() - 0.5D) * 0.2D;
 
-		Color color = Colors.allRedstoneColors[meta & 0xF];
+        final int redstoneBrightness = meta & 0xF;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
 		if(color == null) {
 			return;
 		}
@@ -435,7 +436,7 @@ public class BlockRedstoneWire extends Block
 		float green = color.getGreen() / 255.0f;
 		float blue = color.getBlue() / 255.0f;
 
-		world.spawnParticle("reddust", px, py, pz, red, green, blue, 0);
+		world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 	}
 
     public static boolean isPowerProviderOrWire(WorldSource iblockaccess, int i, int j, int k, int l)
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
index bde3c5884..f369ea782 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
@@ -5,6 +5,8 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -96,7 +98,7 @@ public class BlockTrapDoor extends Block
     
     @Override
     public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
-    	if(!player.isSneaking()) {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		blockActivated(world, x, y, z, player);
     	}
     }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
index 66ad711d8..f4fc52261 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryRepairable.java
@@ -75,7 +75,7 @@ public class RecipeEntryRepairable extends RecipeEntryCraftingDynamic {
 
         for (int i = 0; i < repairMaterialCount; i++)
         {
-            if (inItemStack.getMetadata() < inItemStack.getMaxDamage())
+            if (inItemStack.getMetadata() <= inItemStack.getMaxDamage())
             {
                 inItemStack.setMetadata(inItemStack.getMetadata() - inItemStack.getMaxDamage() / 8);
             }
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index cf12da4c0..c7ce5292d 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -16,6 +16,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -728,7 +729,7 @@ public abstract class Entity
 
     public boolean checkAndHandleWater(boolean addVelocity)
     {
-        return world.handleMaterialAcceleration(bb.expand(0.0D, -0.40000000596046448D, 0.0D).getInsetBoundingBox(0.001D, 0.001D, 0.001D), Material.water, this, addVelocity);
+        return world.handleMaterialAcceleration(bb/*.expand(0.0D, -0.4D, 0.0D)*/.getInsetBoundingBox(0.001D, 0.001D, 0.001D), Material.water, this, addVelocity);
     }
 
     public boolean isUnderLiquid(Material material)
@@ -757,7 +758,7 @@ public abstract class Entity
 
     public boolean isInLava()
     {
-        return world.isMaterialInBB(bb.expand(-0.1D, -0.4D, -0.1D), Material.lava);
+        return world.isMaterialInBB(bb/*.expand(-0.1D, -0.4D, -0.1D)*/, Material.lava);
     }
 
     public void moveRelative(float f, float f1, float f2)
@@ -1483,6 +1484,9 @@ public abstract class Entity
                 return ((EntityLiving) entity).nickname;
             }
         }
+        if (entity instanceof EntityPlayer){
+            return ((EntityPlayer) entity).getDisplayName();
+        }
         if (MobInfoRegistry.getMobInfo(entity.getClass()) != null){
             return translator.translateKey(MobInfoRegistry.getMobInfo(entity.getClass()).getNameTranslationKey());
         }
diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/EntityLiving.java
index f93497ea8..9f302adf5 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/EntityLiving.java
@@ -533,15 +533,15 @@ public abstract class EntityLiving extends Entity
         }
     }
 
-    public void onDeath(Entity entity)
+    public void onDeath(Entity entityKilledBy)
     {
-        if(scoreValue >= 0 && entity != null)
+        if(scoreValue >= 0 && entityKilledBy != null)
         {
-            entity.awardKillScore(this, scoreValue);
+            entityKilledBy.awardKillScore(this, scoreValue);
         }
-        if(entity != null)
+        if(entityKilledBy != null)
         {
-            entity.killed(this);
+            entityKilledBy.killed(this);
         }
         dead = true;
         if(!world.isClientSide)
@@ -553,8 +553,44 @@ public abstract class EntityLiving extends Entity
             vehicle = null;
         }
         world.sendTrackedEntityStatusUpdatePacket(this, (byte)3);
+        if (sendDeathMessage(entityKilledBy)){
+            world.sendGlobalMessage(getDeathMessage(entityKilledBy));
+        }
     }
 
+    public boolean sendDeathMessage(Entity entityKilledBy){
+        return !nickname.isEmpty();
+    }
+    public String getDeathMessage(Entity entityKilledBy){
+        final TextFormatting deathMsgColor = TextFormatting.RED;
+        final TextFormatting reset = TextFormatting.RESET;
+        String name = Entity.getNameFromEntity(this, true);
+        if (entityKilledBy != null){
+            String murdererName = Entity.getNameFromEntity(entityKilledBy, true);
+            return String.format("%s%s was killed by %s%s", name, deathMsgColor, reset, murdererName);
+        }
+        if (world.isMaterialInBB(bb, Material.lava))
+        {
+            return String.format("%s%s swam in lava.", name, deathMsgColor);
+        }
+        if (world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Block.spikes.id)
+        {
+            return String.format("%s%s got impaled.", name, deathMsgColor);
+        }
+        if (fallDistance > 0)
+        {
+            return String.format("%s%s broke their legs.", name, deathMsgColor);
+        }
+        if (airSupply <= 0)
+        {
+            return String.format("%s%s suffocated.", name, deathMsgColor);
+        }
+        if (remainingFireTicks > 0)
+        {
+            return String.format("%s%s was incinerated.", name, deathMsgColor);
+        }
+        return String.format("%s%s died", name, deathMsgColor);
+    }
     protected void dropFewItems()
     {
         List<WeightedRandomLootObject> drops = getMobDrops();
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
index 47b9736ca..76adf674b 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityWolf.java
@@ -54,6 +54,10 @@ public class EntityWolf extends EntityAnimal
             }
         }
     }
+    @Override
+    public boolean sendDeathMessage(Entity entityKilledBy){
+        return super.sendDeathMessage(entityKilledBy) || isWolfTamed();
+    }
 
     public ArmorMaterial getArmorMaterial() {
         ArmorMaterial material = null;
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java b/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
index 16380e8a0..7945ea533 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityCreeper.java
@@ -107,10 +107,10 @@ public class EntityCreeper extends EntityMonster
     }
 
     @Override
-	public void onDeath(Entity entity)
+	public void onDeath(Entity entityKilledBy)
     {
-        super.onDeath(entity);
-        if(entity instanceof EntitySkeleton)
+        super.onDeath(entityKilledBy);
+        if(entityKilledBy instanceof EntitySkeleton)
         {
             spawnAtLocation(Item.record13.id + random.nextInt(11), 1);
         }
